--- asterisk/main/file.c.ORIG	2008-12-18 15:35:18.000000000 -0600
+++ asterisk/main/file.c	2008-12-18 15:26:56.000000000 -0600
@@ -466,9 +466,9 @@
 					continue;
 				}
 				if (open_wrapper(s)) {
-					fclose(bfile);
 					free(fn);
-					free(s);
+					/* ast_closestream closes bfile automatically */
+					ast_closestream(s);
 					continue;	/* cannot run open on file */
 				}
 				/* ok this is good for OPEN */
@@ -969,9 +969,11 @@
 		if (!bfile || (fs = get_filestream(f, bfile)) == NULL ||
 		    open_wrapper(fs) ) {
 			ast_log(LOG_WARNING, "Unable to open %s\n", fn);
-			if (fs)
-				ast_free(fs);
-			fs = NULL;
+			if (fs) {
+				ast_closestream(fs);
+				bfile = NULL; /* closed by ast_closestream */
+				fs = NULL;
+			}
 			if (bfile)
 				fclose(bfile);
 			free(fn);
@@ -1086,9 +1088,10 @@
 					unlink(fn);
 					unlink(orig_fn);
 				}
-				if (fs)
-					ast_free(fs);
-				fs = NULL;
+				if (fs) {
+					ast_closestream(fs);
+					fs = NULL;
+				}
 				continue;
 			}
 			fs->trans = NULL;
